import es
import cPickle
import popuplib
import os.path
import gamethread
import playerlib
import urllib2
import esamlib
import base64
from time import strftime


##################################### Start of Options ##################################################
##################################### Important!!! ######################################################
#                                 You can use now, more than 1 Tag                                      #
##################################### Rank Options ######################################################

clanadmins = ["STEAM_ID_LAN", "Your steamid", ""]                 # Here the Steamid's that are Clanadmins
clanmembers = ["STEAM_ID_LAN", "Your steamid", ""]                # Here the Steamid's that are Clanmembers
costumrank_1 = ["STEAM_ID_LAN", "Your steamid", ""]               # Here the Steamid's for customrank 1
costumrank_2 = ["STEAM_ID_LAN", "Your steamid", ""]               # Here the Steamid's for customrank 2
rank_1 = "Clanleader"                                             # Here the Name of the first customrank
rank_2 = "second Clanleader"                                      # Here the Name of the second customrank

##################################### Update Options #####################################################

updateaddon = 1                                                   # should there come a message, when there is a version 1 = on, 0 = off


##################################### Send Options ######################################################

owntext = "!myinfo"                                               # Command to see one's details

player_send = "all"                                               # "all" send the popup to all players, "joiner" only to the Joiner

popup_timeout = 7                                                 # When should the Popup close in seconds

##################################### End of Options ####################################################

infos = {}
info = es.AddonInfo()
info.name = "playerdetails"
info.version = "2.5"
info.author = "Popoklopsi"
info.url = "www.team-wb.de"
info.basename = "playerdetails"
info.description = "Get the playerdetails from a player when he join" 

def load():
	if base64.decodestring('UG9wb2tsb3BzaQ==\n') != info.author:
		es.msg('#multi', "#green DON'T CHANGE THE AUTHOR NAME")
		es.unload('playerdetails')
	if base64.decodestring("cGxheWVyZGV0YWlscw==\n") != info.basename:
		es.msg('#multi', "#green DON'T CHANGE THE BASENAME")
		es.unload('playerdetails')
	if base64.decodestring("Mi41\n") != info.version:
		es.msg('#multi', "#green DON'T CHANGE THE VERSION")
		es.unload('playerdetails')
	global infos
	file = es.getAddonPath('playerdetails') + '/infos2-5.db'
	if os.path.isfile(file):
		file_players = open(file)
		infos = cPickle.load(file_players)
		file_players.close()
	es.set("%s" % info.basename,info.version)
	es.makepublic("%s" % info.basename)
	es.msg('#multi', '#green Playerdetails loaded')

def es_map_start(ev):
	if updateaddon == 1:
		gamethread.delayed(60, nowupdate, ())
		
def round_start(ev):
	save_dictionary()

def unload():
	save_dictionary()

def nowupdate():
	if not int(es.ServerVar("sv_lan")):
		q = esamlib.getAddon("playerdetails")
		try:
			newest_version = q.currentversion
		except:
			es.dbgmsg(0, "[Playerdetails] Not possbile to connect to Page!")
		if str(info["version"]) != str(newest_version):
			es.centermsg("There is a new Version for Playerdetails") 
			es.msg("#multi", "#lightgreen [ #green Playerdetails #lightgreen ] #green A new Version is available for #lightgreen Playerdetails")
			playerpopup2 = popuplib.create('playerpopup2')
			playerpopup2.addline("Playerdetails Update info")
			playerpopup2.addline('-----------------------------------------------------------')
			playerpopup2.addline("There is a new Version from Playerdetails")
			playerpopup2.addline(" ")
			playerpopup2.addline("Update at:")
			playerpopup2.addline(" ")
			playerpopup2.addline("http://addons.eventscripts.com/addons/view/playerdetails")
			playerpopup2.addline('-----------------------------------------------------------')
			for x in es.getUseridList():
				popuplib.send('playerpopup2', x) 
				gamethread.delayed(15, popuplib.unsendname, ("playerpopup2",  x))

def es_player_validated(ev):
	steamid1 = ev["networkid"]
	if steamid1 != 'BOT':
		if steamid1 != 'STEAM_ID_PENDING':
			if not infos.has_key(steamid1):
				infos[steamid1] = {} 
				infos[steamid1]["connects"] = 0 
				infos[steamid1]["spawns"] = 0
				infos[steamid1]["kills"] = 0 
				infos[steamid1]["deaths"] = 0
				infos[steamid1]["headshots"] = 0
				infos[steamid1]["last"] = 0 
			if infos.has_key(steamid1):
				infos[steamid1]["connects"] = infos[steamid1]["connects"] + 1
				infos[steamid1]["spawns"] = infos[steamid1]["spawns"] - 1
					
def player_death(ev):
	steamid3 = ev["es_steamid"]
	steamid4 = ev["es_attackersteamid"]
	if steamid3 != 'BOT':
		if steamid3 != 'STEAM_ID_PENDING':
			if ev["es_attackerteam"] != ev["es_userteam"]:
				infos[steamid3]["deaths"] = infos[steamid3]["deaths"] + 1
	if steamid4 != 'BOT':
		if steamid4 != 'STEAM_ID_PENDING':
			if ev["es_attackerteam"] != ev["es_userteam"]:
				infos[steamid4]["kills"] = infos[steamid4]["kills"] + 1
	if ev['headshot'] == '1':
		if steamid4 != 'BOT':
			if steamid4 != 'STEAM_ID_PENDING':
				infos[steamid4]["headshots"] = infos[steamid4]["headshots"] + 1
		
def player_spawn(ev):
	steamid5 = ev['es_steamid']
	if steamid5 != 'BOT':
		if steamid5 != 'STEAM_ID_PENDING':
			infos[steamid5]["spawns"] = infos[steamid5]["spawns"] + 1
			
def player_say(ev):
	if ev['text'] == owntext:
		playersteamid = ev["es_steamid"]
		theuserid = ev["userid"]
		name = ev["es_username"]
		if playersteamid != 'BOT':
			if playersteamid != 'STEAM_ID_PENDING':
				rank = ""
				if playersteamid in clanadmins:
					if rank == "":
						rank = "Admin"
					else:
						rank = '%s, Admin' %(rank)
				if playersteamid in clanmembers:
					if rank == "":
						rank = "Clanmember"
					else:
						rank = '%s, Clanmember' % rank
				if playersteamid in costumrank_1:
					if rank == "":
						rank = rank_1		
					else:
						rank = '%s, %s' % (rank, rank_1)
				if playersteamid in costumrank_2:
					if rank == "":
						rank = rank_2		
					else:
						rank = '%s, %s' %(rank, rank_2)
				if playersteamid not in clanadmins:
					if playersteamid not in clanmembers:
						if playersteamid not in costumrank_1:
							if playersteamid not in costumrank_2:
									rank = "User"
				playerpopup1 = popuplib.create('playerpopup1')
				playerpopup1.addline("Infos About: %s" % str(name))
				playerpopup1.addline("Rank: %s" % str(rank))
				playerpopup1.addline('-----------------------------')
				playerpopup1.addline("Steamid: %s" % str(playersteamid))
				playerpopup1.addline("Last Connect: %s" % infos[playersteamid]["last"])
				playerpopup1.addline("Total Connects: %i" % infos[playersteamid]["connects"])
				playerpopup1.addline("Total Spawns: %i" % infos[playersteamid]["spawns"])
				playerpopup1.addline("Total Kills: %i" % infos[playersteamid]["kills"])
				playerpopup1.addline("Total Deaths: %i" % infos[playersteamid]["deaths"])
				playerpopup1.addline("Total Headshots: %i" % infos[playersteamid]["headshots"])
				playerpopup1.addline('-----------------------------')
				playerpopup1.addline('->0. Close')
				playerpopup1.submenu(1, "playerpopup1")
				playerpopup1.submenu(2, "playerpopup1")
				playerpopup1.submenu(3, "playerpopup1")
				playerpopup1.submenu(4, "playerpopup1")
				playerpopup1.submenu(5, "playerpopup1")
				playerpopup1.submenu(6, "playerpopup1")
				playerpopup1.submenu(7, "playerpopup1")
				playerpopup1.submenu(8, "playerpopup1")
				playerpopup1.submenu(9, "playerpopup1")
				popuplib.send('playerpopup1', ev["userid"])
				gamethread.delayed(popup_timeout, popuplib.unsendname, ("playerpopup1",  ev["userid"]))

def player_disconnect(ev):
	time = str(strftime("%a, %d %b %Y %H:%M:%S"))
	steamid2 = ev["es_steamid"]
	if steamid2 != 'BOT':
		if steamid2 != 'STEAM_ID_PENDING':
			infos[steamid2]["last"] = time

def player_activate(ev):
	playersteamid = ev["es_steamid"]
	theuserid = ev["userid"]
	name = ev["es_username"]
	if playersteamid != 'BOT':
		if playersteamid != 'STEAM_ID_PENDING':
			rank = ""
			if playersteamid in clanadmins:
				if rank == "":
					rank = "Admin"
				else:
					rank = '%s, Admin' %(rank)
			if playersteamid in clanmembers:
				if rank == "":
					rank = "Clanmember"
				else:
					rank = '%s, Clanmember' %(rank)
			if playersteamid in costumrank_1:
				if rank == "":
					rank = rank_1		
				else:
					rank = '%s, %s' %(rank, rank_1)
			if playersteamid in costumrank_2:
				if rank == "":
					rank = rank_2		
				else:
					rank = '%s, %s' %(rank, rank_2)
			if playersteamid not in clanadmins:
				if playersteamid not in clanmembers:
					if playersteamid not in costumrank_1:
						if playersteamid not in costumrank_2:
								rank = "User"
			playerpopup1 = popuplib.create('playerpopup1')
			playerpopup1.addline("Infos About: %s" % str(name))
			playerpopup1.addline("Rank: %s" % str(rank))
			playerpopup1.addline('-----------------------------')
			playerpopup1.addline("Steamid: %s" % str(playersteamid))
			playerpopup1.addline("Last Connect: %s" % infos[playersteamid]["last"])
			playerpopup1.addline("Total Connects: %i" % infos[playersteamid]["connects"])
			playerpopup1.addline("Total Spawns: %i" % infos[playersteamid]["spawns"])
			playerpopup1.addline("Total Kills: %i" % infos[playersteamid]["kills"])
			playerpopup1.addline("Total Deaths: %i" % infos[playersteamid]["deaths"])
			playerpopup1.addline("Total Headshots: %i" % infos[playersteamid]["headshots"])
			playerpopup1.addline('-----------------------------')
			playerpopup1.addline('->0. Close')
			playerpopup1.submenu(1, "playerpopup1")
			playerpopup1.submenu(2, "playerpopup1")
			playerpopup1.submenu(3, "playerpopup1")
			playerpopup1.submenu(4, "playerpopup1")
			playerpopup1.submenu(5, "playerpopup1")
			playerpopup1.submenu(6, "playerpopup1")
			playerpopup1.submenu(7, "playerpopup1")
			playerpopup1.submenu(8, "playerpopup1")
			playerpopup1.submenu(9, "playerpopup1")
			if player_send == "all":
				for x in es.getUseridList():
					popuplib.send('playerpopup1', x)
					gamethread.delayed(popup_timeout, popuplib.unsendname, ("playerpopup1",  x))
			if player_send == "joiner":
					popuplib.send('playerpopup1', ev["userid"])
					gamethread.delayed(popup_timeout, popuplib.unsendname, ("playerpopup1",  ev["userid"]))
    
def save_dictionary():
	file_players = open(es.getAddonPath('playerdetails') + '/infos2-5.db', 'wb')
	cPickle.dump(infos, file_players)
	file_players.close()